/** Demo Instrument
*
*	This patch is a demonstration of the most basic HISE features.
*/

// Load a background image
const var bgImage = Content.addImage("bgImage", 0, 0);


// Tell the engine to use this script as main interface
Content.makeFrontInterface(bgImage.get("width"), bgImage.get("height"));

// Set the key colours randomly
for(i = 0; i < 50; i++)
{
	Engine.setKeyColour(i, 0x88000000);
}

for(i = 50; i < 90; i++)
{
	Engine.setKeyColour(i, 0x22ffffff);
}

for(i = 90; i < 128; i++)
{
	Engine.setKeyColour(i, 0x88000000);
}

// Set the lowest visible key
Engine.setLowestKeyToDisplay(28);

/** Creates the slider. This is a autogenerated UI Factory function. */
inline function createVolumeSlider(name, x, y)
{
	local widget = Content.addKnob(name, x, y);
    
    Content.setPropertiesFromJSON(name, {
      "text": "Volume",
      "min": -100,
      "max": 0,
      "middlePosition": -12,
      "mode": "Decibel",
      "stepSize": 0.10000000000000000555,
      "suffix": " dB"
    });
    
    return widget;
};

const var volumeSlider = createVolumeSlider("volumeSlider", 164, 111);

const var SimpleGain = Synth.getEffect("Simple Gain");

// This is a table that connects to the sampler's velocity modulator
const var velocityTable = Content.addTable("velocityTable", 115, 196);
// [JSON velocityTable]
Content.setPropertiesFromJSON("velocityTable", {
  "width": 470,
  "height": 189,
  "processorId": "SamplerVelocity"
});
// [/JSON velocityTable]
const var irSlider = Content.addKnob("irSlider", 361, 112);
// [JSON irSlider]
Content.setPropertiesFromJSON("irSlider", {
  "text": "Reverb Amount",
  "width": 144,
  "macroControl": "Macro 1"
});
// [/JSON irSlider]



const var SampleMapSelector = Content.addComboBox("SampleMapSelector", 283, 405);

const var DemoSampler = Synth.getSampler("DemoSampler");

SampleMapSelector.set("items", "");

const var x = Sampler.getSampleMapList();
for(sampleMap in x) SampleMapSelector.addItem(sampleMap);



inline function onSampleMapSelectorControl(component, value)
{
	DemoSampler.loadSampleMap(SampleMapSelector.getItemText());
};

SampleMapSelector.setControlCallback(onSampleMapSelectorControl);
function onNoteOn()
{
	
}
 function onNoteOff()
{
	
}
 function onController()
{
	
}
 function onTimer()
{
	
}
 function onControl(number, value)
{
	switch(number)
	{
		case volumeSlider:
		{
			SimpleGain.setAttribute(SimpleGain.Gain, value);
			break;
		}
	};
}
