; Script generated by the Inno Script Studio Wizard.
; SEE THE DOCUMENTATION FOR DETAILS ON CREATING INNO SETUP SCRIPT FILES!

#define MyAppName "$PRODUCT"
#define MyAppVersion "$VERSION_POINT"
#define MyAppPublisher "$COMPANY"
#define MyAppURL "$WEBSITE"

[Setup]
; NOTE: The value of AppId uniquely identifies this application.
; Do not use the same AppId value in installers for other applications.
; (To generate a new GUID, click Tools | Generate GUID inside the IDE.)
AppId= {{01F93846-3497-4390-BB80-6456826EABA0}

AppName={#MyAppName}
AppVersion={#MyAppVersion}
;AppVerName={#MyAppName} {#MyAppVersion}
AppPublisher={#MyAppPublisher}
AppPublisherURL={#MyAppURL}
AppSupportURL={#MyAppURL}
AppUpdatesURL={#MyAppURL}
DefaultDirName={pf}\{#MyAppName}
DefaultGroupName={#MyAppName}
LicenseFile="..\..\license.txt"
ArchitecturesInstallIn64BitMode=x64
SetupLogging=yes
OutputBaseFilename=$PRODUCT_$VERSION_UNDERSCORE
Compression=lzma
SolidCompression=yes

[Languages]
Name: "english"; MessagesFile: "compiler:Default.isl"

[Components]
Name: "x64Plugin"; Description: "64bit VST Plugin Stereo Out"; Types: compact custom full
Name: "Standalone64bit"; Description: "64bit Standalone application"; ExtraDiskSpaceRequired: 9000; Types: full compact custom

[Files]
Source: "..\..\projects\standalone\Builds\VisualStudio2017\x64\Release\App\$PRODUCT.exe"; DestDir: "{app}"; Flags: 64bit; Components: Standalone64bit
Source: "..\..\projects\plugin\Builds\VisualStudio2017\x64\Release\VST\$PRODUCT x64.dll"; DestDir: "{code:Getx64bitDir}"; Flags: 64bit; Components: x64Plugin

[Icons]
Name: "{group}\{cm:UninstallProgram,{#MyAppName}}"; Filename: "{uninstallexe}"; 

Name: "{group}\$PRODUCT"; Filename: "{app}\$PRODUCT.exe"; Components: Standalone64bit

[Dirs]

[Code]
var x64Page: TInputDirWizardPage;

procedure InitializeWizard;
begin
  // Create the page
  x64Page := CreateInputDirPage(wpSelectComponents,
    'Select VST 64bit Plugin Folder', 'Where should the 64bit version of the VST Plugin be installed?',
    'Select your VST 64bit Folder',
    False, '');
  x64Page.Add('');

  x64Page.Values[0] := GetPreviousData('x64', '');

end;

function ShouldSkipPage(PageID: Integer): Boolean;
begin

  if PageFromID(PageID) = x64Page then Result := not isComponentSelected('x64Plugin');

end;


function NextButtonClick(CurPageID: Integer): Boolean;
begin

  // Set default folder if empty
  if (IsWin64) and (x64Page.Values[0] = '') then
     x64Page.Values[0] := ExpandConstant('{pf64}\VSTPlugins');
  Result := True;
end;

function Getx64bitDir(Param: String): String;
begin
  { Return the selected DataDir }
  Result := x64Page.Values[0];
end;